Package: catdata
Type: Package
Title: Categorical Data
Version: 1.2.5
Date: 2025-12-04
Encoding: UTF-8
Depends: MASS
Suggests: knitr, rms, qvcalc, glmmML, nnet, pscl, VGAM, gee, mlogit,
        Ecdat, geepack, mgcv, rpart, party, ordinal, lme4, vcdExtra,
        glmnet, mboost, class, e1071, flexmix, lpSolve, penalized
Authors@R: c(person(given = "Gunther",
                        family = "Schauberger",
                        role = c("aut", "cre"),
                        email = "gunther.schauberger@tum.de"),
                 person(given = "Gerhard",
                        family = "Tutz",
                        role = "aut"))
Maintainer: Gunther Schauberger <gunther.schauberger@tum.de>
Description: This R-package contains examples from the book "Regression for Categorical Data", Tutz 2012, Cambridge University Press. The names of the examples refer to the chapter and the data set that is used. 
License: GPL-2
LazyLoad: yes
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2025-12-04 08:53:55 UTC; ge29weh
Author: Gunther Schauberger [aut, cre],
  Gerhard Tutz [aut]
Repository: CRAN
Date/Publication: 2025-12-04 10:00:02 UTC
Built: R 4.6.0; ; 2026-04-27 00:11:25 UTC; unix

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----eval=FALSE---------------------------------------------------------------
# library(mlogit)

## ----eval=FALSE---------------------------------------------------------------
# data(ModeChoice, package="Ecdat")

## ----eval=FALSE---------------------------------------------------------------
# travel.long <- mlogit.data(ModeChoice, choice="mode", shape="long", alt.levels=
# c("air","train","bus","car"))

## ----eval=FALSE---------------------------------------------------------------
# travel.kat.id <- mlogit(mode ~ invt + gc|hinc, data=travel.long)
# summary(travel.kat.id)

## ----eval=FALSE---------------------------------------------------------------
# library(VGAM)

## ----eval=FALSE---------------------------------------------------------------
# travelmode <- matrix(ModeChoice$mode, byrow = T, ncol = 4)
# colnames(travelmode) <- c("air","train","bus","car")
# travelhinc <- matrix(ModeChoice$hinc, byrow = T, ncol = 4)
# travelhinc <- travelhinc[,1]
# travelinvt <- matrix(ModeChoice$invt, byrow = T, ncol = 4)
# colnames(travelinvt) <- c("invtair","invttrain","invtbus","invtcar")
# travelgc <- matrix(ModeChoice$gc, byrow = T, ncol = 4)
# colnames(travelgc) <- c("gcair","gctrain","gcbus","gccar")
# 
# travelinvt <- sweep(travelinvt[,-1], 1, travelinvt[,1])
# travelgc <- sweep(travelgc[,-1], 1, travelgc[,1])
# 
# 
# Invt <- travelinvt[,1]
# Gc <- travelgc[,1]
# 
# traveldat <- cbind(travelhinc, travelinvt, Invt, travelgc, Gc)
# traveldat <- as.data.frame(traveldat)

## ----eval=FALSE---------------------------------------------------------------
# fit <- vglm(travelmode ~ Invt + Gc + travelhinc,
#             multinomial(parallel = FALSE ~ travelhinc, refLevel = 1),
#             xij = list(Invt ~ invttrain + invtbus + invtcar,
#                        Gc ~ gctrain + gcbus + gccar),
#             form2 = ~ Invt + invttrain + invtbus + invtcar +
#                       Gc + gctrain + gcbus + gccar + travelhinc,
#             data = traveldat, trace = TRUE)
# 
# summary(fit)
# summary(travel.kat.id)

## ----eval=FALSE---------------------------------------------------------------
# summary(travel.kat.id)$CoefTable
# summary(fit)@coef3

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# detach(package:VGAM)
# detach(package:mlogit)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=85)

## ----results='hide',eval=FALSE------------------------------------------------
# library(catdata)
# data(addiction)
# attach(addiction)

## ----eval=FALSE---------------------------------------------------------------
# library(nnet)

## ----eval=FALSE---------------------------------------------------------------
# ill <- as.factor(ill)
# addiction$ill<-as.factor(addiction$ill)

## ----eval=FALSE---------------------------------------------------------------
# multinom0 <- multinom(ill ~ gender + age + university, data=addiction)
# summary(multinom0)

## ----eval=FALSE---------------------------------------------------------------
# library(VGAM)
# multivgam0<-vglm(ill ~ gender + age + university, multinomial(refLevel=1),
#                  data=addiction)
# summary(multivgam0)

## ----eval=FALSE---------------------------------------------------------------
# addiction$age2 <- addiction$age^2
# multinom1 <- update(multinom0, . ~ . + age2)
# summary(multinom1)
# 
# multivgam1<-vglm(ill ~ gender + age + university + age2, multinomial(refLevel=1),
#                  data=addiction)
# summary(multivgam1)

## ----eval=FALSE---------------------------------------------------------------
# anova(multinom0,multinom1)
# multinom1$dev - multinom0$dev

## ----eval=FALSE---------------------------------------------------------------
# minage <- min(na.omit(age))
# maxage <- max(na.omit(age))
# 
# ageindex <- seq(minage, maxage, 0.1)
# n <- length(ageindex)

## ----eval=FALSE---------------------------------------------------------------
# ageindex2 <- ageindex^2
# 
# gender1 <- rep(1, n)
# gender0 <- rep(0, n)
# university1 <- rep(1, n)
# 
# datamale <- as.data.frame(cbind(gender=gender0,age=ageindex,university=
#   university1,age2=ageindex2))
# datafemale <- as.data.frame(cbind(gender=gender1,age=ageindex,university=
#   university1,age2=ageindex2))

## ----eval=FALSE---------------------------------------------------------------
# probsmale <- predict(multinom1, datamale, type="probs")
# probsfemale <- predict(multinom1, datafemale, type="probs")

## ----echo=TRUE,eval=FALSE-----------------------------------------------------
# par(cex=1.4, lwd=2)
# 
# plot(ageindex, probsmale[,1], type="l", lty=1, ylim=c(0,1), main=
# "men with university degree", ylab="probabilities")
# lines(ageindex, probsmale[,2], lty="dotted")
# lines(ageindex, probsmale[,3], lty="dashed")
# legend("topright", legend=c("Weak-willed", "diseased", "both"), lty=c("solid",
# "dotted", "dashed"))

## ----echo=TRUE,eval=FALSE-----------------------------------------------------
# par(cex=1.4, lwd=2)
# 
# plot(ageindex, probsfemale[,1], type="l", lty=1, ylim=c(0,1), main=
#   "women with university degree", ylab="probabilities")
# lines(ageindex, probsfemale[,2], lty="dotted")
# lines(ageindex, probsfemale[,3], lty="dashed")
# legend("topright", legend=c("Weak-willed", "diseased", "both"),
#        lty=c("solid", "dotted", "dashed"))

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----eval=FALSE---------------------------------------------------------------
# library(catdata)
# data(unemployment,package="catdata")

## ----fig.width=9,eval=FALSE---------------------------------------------------
# library(party)
# tree1<-ctree(as.factor(durbin)~age,data=unemployment)
# 
# plot(tree1)

## ----eval=FALSE---------------------------------------------------------------
# unemployment$durbin[unemployment$durbin==2]<-0
# year<- unemployment$age
# year [unemployment$age<29.5] <- 1
# year [unemployment$age>29.5 & unemployment$age<52.5] <- 2
# year [unemployment$age>52.5] <- 3
#  	
# pre3 <- mean(unemployment$durbin[year==3])
# pre2 <- mean(unemployment$durbin[year==2])
# pre1 <- mean(unemployment$durbin[year==1])
# 
# meanyear <- c()
# 
# for (i in min(unemployment$age):max(unemployment$age)){
# meanyear[i] <- sum(unemployment$durbin[unemployment$age==i])
# if(sum(unemployment$durbin[unemployment$age==i])!=0){
# meanyear[i] <- mean(unemployment$durbin[unemployment$age==i])
# }
# }
# 
# unemployment$means<- rep(2, nrow(unemployment))
# 
#  for (k in 1:nrow(unemployment)){
#  unemployment$means[k] <- meanyear[unemployment$age[k]]
#  }

## ----fig.width=9,eval=FALSE---------------------------------------------------
#   plot(unemployment$age, unemployment$means, xlab="age",ylab="",cex.axis=1.5,
#        cex.lab=1.5)
#  segments(x0=min(unemployment$age),x1=29.5,y0=pre1)
#  segments(x0=29.5,x1=29.5,y0=pre1,y1=pre2)
#  segments(x0=29.5,x1=52.5,y0=pre2)
#  segments(x0=52.5,x1=52.5,y0=pre2,y1=pre3)
#  segments(x0=52.5,x1=max(unemployment$age),y0=pre3)

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# detach(package:party)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=85)

## ----eval=FALSE---------------------------------------------------------------
# unemployment <- matrix(c(97, 216, 56, 34, 105, 91, 31, 11,
#                   45, 81, 32, 9, 51, 81, 34, 9), nrow=8, ncol=2)
# rownames(unemployment) <- c(paste("male", 1:4), paste("female", 1:4))
# colnames(unemployment) <- c("Short term","Long term")
# unemployment

## ----eval=FALSE---------------------------------------------------------------
# y <- c(rep(1, sum(97, 216, 56, 34, 105, 91, 31, 11)),
#        rep(0, sum(45, 81, 32, 9, 51, 81, 34, 9)))
# 
# G <- c(rep(1, sum(97, 216, 56, 34)), rep(0, sum(105, 91, 31, 11)),
#        rep(1, sum(45, 81, 32, 9)), rep(0, sum(51, 81, 34, 9)))
# 
# L <- factor(c(rep(1, 97), rep(2, 216), rep(3, 56), rep(4, 34),
#        rep(1, 105), rep(2, 91), rep(3, 31), rep(4, 11),
#        rep(1, 45), rep(2, 81), rep(3, 32), rep(4, 9),
#        rep(1, 51), rep(2, 81), rep(3, 34), rep(4, 9)))
# 
# table(G,L,y)

## ----eval=FALSE---------------------------------------------------------------
# unemp_1 <- glm(y ~ 1,family=binomial)
# unemp_G <- glm(y ~ G,family=binomial)
# unemp_L <- glm(y ~ L,family=binomial)
# unemp_LG <- glm(y ~ G + L,family=binomial)
# unemp_sat <- glm(y ~ G * L,family=binomial)
# summary(unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
# anova(unemp_LG, unemp_sat)
# anova(unemp_L, unemp_LG)
# anova(unemp_1, unemp_L)
# 
# anova(unemp_LG, unemp_sat)
# anova(unemp_G, unemp_LG)
# anova(unemp_1, unemp_G)

## ----eval=FALSE---------------------------------------------------------------
# anova(unemp_1, unemp_sat)
# anova(unemp_L, unemp_sat)
# anova(unemp_G, unemp_sat)
# anova(unemp_LG, unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
# genderleveldat<-data.frame("Long term"=unemployment[,1],
# "Short term"=unemployment[,2],"Level"=rep(1:4,2),"Gender"=rep(c(1,0),each=4))
# 
# groupintercept<-glm(cbind(Long.term, Short.term) ~ 1, family=binomial,
#                     data=genderleveldat)
# summary(groupintercept)
# 
# #Corresponding un-grouped model:
# summary(unemp_1)
# 
# groupgender<-glm(cbind(Long.term, Short.term) ~ Gender, family=binomial,
#                  data=genderleveldat)
# summary(groupgender)
# 
# #Corresponding un-grouped model:
# summary(unemp_G)
# 
# 
# grouplevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Level), family=binomial,
#                 data=genderleveldat)
# summary(grouplevel)
# 
# #Corresponding un-grouped model:
# summary(unemp_L)
# 
# 
# groupgenderlevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) +
#   as.factor(Level), family=binomial, data=genderleveldat)
# summary(groupgenderlevel)
# 
# #Corresponding un-grouped model:
# summary(unemp_LG)
# 
# groupsat<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) * as.factor(Level),
#               family=binomial, data=genderleveldat)
# summary(groupsat)
# 
# #Corresponding un-grouped model:
# summary(unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
# anova(groupgenderlevel, groupsat)
# anova(grouplevel, groupgenderlevel)
# anova(groupintercept, grouplevel)
# 
# 
# anova(groupgenderlevel, groupsat)
# anova(groupgender, groupgenderlevel)
# anova(groupintercept, groupgender)

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# rm(unemployment)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----eval=FALSE---------------------------------------------------------------
# library(catdata)
# data(medcare)
# 
# library(MASS)
# library(pscl)

## ----eval=FALSE---------------------------------------------------------------
# medmale <- medcare[medcare$male==1,]
# medmale <-medmale[medmale$ofp<=30,]

## ----eval=FALSE---------------------------------------------------------------
# set.seed(5)
# 
# subs<-1:nrow(medmale)
# 
# reps <- 50
# 
# squerror1<-squerror3<-squerror4<-squerror5<-squerror6<-squerror7<-c()
# abserror1<-abserror3<-abserror4<-abserror5<-abserror6<-abserror7<-c()
# 
# 
# for(i in 1:reps){
# learn <- sample(subs,600)
# test <- subs[-learn]
# 
# ###########################
# med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#         family=poisson,data=medmale[learn,])
# l <- predict(med, newdata=medmale[test,], type="response")
# 
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# while(ppois(a[j],lambda=l[j])<0.5){
# a[j] <- a[j] + 1
# }
# }
# diffs <- a - medmale[test,1]
# squerror1[i]<-mean(diffs^2)
# abserror1[i]<-mean(abs(diffs))
# 
# ######################
# med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# l <- predict(med3, newdata=medmale[test,], type="response")
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# 
# while((pnbinom(a[j],mu=l[j],size=med3$theta))<0.5){
# a[j] <- a[j]+1
# }
# }
# 
# diffs <- a - medmale[test,1]
# squerror3[i]<-mean(diffs^2)
# abserror3[i]<-mean(abs(diffs))
# 
# ##################
# med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#               data=medmale[learn,])
# pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
# mui <- predict(med4, newdata=medmale[test,], type="count")
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- 0
# 
# while(cdis<0.5){
# 
# cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
#   I(a[j]==0)
# a[j] <- a[j]+1
# }
# a[j]<-a[j] - 1
# }
# diffs <- a - medmale[test,1]
# squerror4[i]<-mean(diffs^2)
# abserror4[i]<-mean(abs(diffs))
# 
# ################################
# med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#               data=medmale[learn,])
# 
# pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
# mui <- predict(med5, newdata=medmale[test,], type="count")
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- 0
# 
# while(cdis<0.5){
# 
# cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
#   I(a[j]==0)
# a[j] <- a[j]+1
# }
# a[j]<-a[j] - 1
# }
# 
# diffs <- a - medmale[test,1]
# 
# squerror5[i]<-mean(diffs^2)
# abserror5[i]<-mean(abs(diffs))
# 
# ####################
# med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#             data=medmale[learn,])
# mui <- predict(med6, newdata=medmale[test,], type="count")
# gammai <- predict(med6, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- pii2[j]
# 
# if(cdis<0.5){
# while(cdis<0.5){
# #while((1-cumdist)>eps){
# cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
# a[j]<-a[j]+1
# #a <- a+1
# }
# }
# else{a[j]<-0}
# }
# 
# diffs <- a - medmale[test,1]
# 
# squerror6[i]<-mean(diffs^2)
# abserror6[i]<-mean(abs(diffs))
# 
# #######################
# med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# mui <- predict(med7, newdata=medmale[test,], type="count")
# gammai <- predict(med7, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- pii2[j]
# 
# if(cdis<0.5){
# while(cdis<0.5){
# #while((1-cumdist)>eps){
# cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
# a[j]<-a[j]+1
# }
# }
# else{a[j]<-0}
# }
# 
# diffs <- a - medmale[test,1]
# 
# squerror7[i]<-mean(diffs^2)
# abserror7[i]<-mean(abs(diffs))
# 
# }

## ----fig.width=12,eval=FALSE--------------------------------------------------
# par(mgp=c(0,3,0))
# boxplot(abserror1,abserror3,abserror4,abserror5,abserror6,abserror7,
# names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
#         "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)

## ----eval=FALSE---------------------------------------------------------------
# library(catdata)
# data(medcare)
# #attach(medcare)
# 
# library(MASS)
# library(pscl)
# 
# medmale <- medcare[medcare$male==1,]
# medmale <-medmale[medmale$ofp<=30,]
# set.seed(5)
# 
# subs<-1:nrow(medmale)
# 
# reps <- 50
# 
# eps <- 1e-5
# 
# lrps <- lrps3 <- lrps4 <- lrps5 <- lrps6 <- lrps7 <- rep(0,reps)
# 
# for(i in 1:reps){
# learn <- sample(subs,600)
# test <- subs[-learn]
# 
# 
# med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#         family=poisson,data=medmale[learn,])
# 
# l <- predict(med, newdata=medmale[test,], type="response")
# 
# 
# for(j in 1:length(medmale[test,1])){
# for(a in 0:100){
# #while((1-ppois(a,lambda=l[j]))>eps){
# lrps[i] <- lrps[i] + (ppois(a,lambda=l[j]) - I(medmale[test,1][j] <= a))^2
# #a <- a+1
# }
# }
# 
# 
# med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# l <- predict(med3, newdata=medmale[test,], type="response")
# 
# for(j in 1:length(medmale[test,1])){
# #a <- 0
# for (a in 0:100){
# #while((1-pnbinom(a,mu=l[j],size=med3$theta))>eps){
# lrps3[i] <- lrps3[i] + (pnbinom(a,mu=l[j],size=med3$theta) -
#   I(medmale[test,1][j] <= a))^2
# #a <- a+1
# }
# }
# 
# 
# med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#               data=medmale[learn,])
# pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
# mui <- predict(med4, newdata=medmale[test,], type="count")
# 
# 
# for(j in 1:length(medmale[test,1])){
# a <- 0
# cumdist<-(1-pii[j])
# #cumdist <- 0
# for (a in 0:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
# lrps4[i] <- lrps4[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# #a <- a+1
# }
# }
# 
# 
# med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#               data=medmale[learn,])
# pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
# mui <- predict(med5, newdata=medmale[test,], type="count")
# 
# for(j in 1:length(medmale[test,1])){
# a <- 0
# cumdist<-(1-pii[j])
# #cumdist <- 0
# for (a in 0:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
# lrps5[i] <- lrps5[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# #a <- a+1
# }
# }
# 
# 
# med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#             data=medmale[learn,])
# mui <- predict(med6, newdata=medmale[test,], type="count")
# gammai <- predict(med6, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# #rr<-coef(med6,model="zero")
# 
# #pii<-exp(rr)/(1+exp(rr))
# 
# #ga<-(1-pii)/(1-exp(-mui))
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# for(j in 1:length(medmale[test,1])){
# cumdist <- pii2[j]
# 
# for(a in 1:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
# lrps6[i] <- lrps6[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# 
# #a <- a+1
# }
# }
# 
# 
# 
# med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# mui <- predict(med7, newdata=medmale[test,], type="count")
# gammai <- predict(med7, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# for(j in 1:length(medmale[test,1])){
# cumdist <- pii2[j]
# 
# for(a in 1:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
# lrps7[i] <- lrps7[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# 
# #a <- a+1
# }
# }
# 
# }
# 
# 
# lrps <-lrps/length(medmale[test,1])
# lrps3 <-lrps3/length(medmale[test,1])
# lrps4 <-lrps4/length(medmale[test,1])
# lrps5 <-lrps5/length(medmale[test,1])
# lrps6 <-lrps6/length(medmale[test,1])
# lrps7 <-lrps7/length(medmale[test,1])

## ----fig.width=12,eval=FALSE--------------------------------------------------
# par(mgp=c(0,3,0))
# boxplot(lrps,lrps3,lrps4,lrps5,lrps6,lrps7,
# names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
#         "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)
# 

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# detach(package:pscl)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----results='hide',eval=FALSE------------------------------------------------
# library(catdata)
# data(birth)
# attach(birth)

## ----eval=FALSE---------------------------------------------------------------
# intensive <- rep(0,length(Intensive))
# intensive[Intensive>0] <- 1
# Intensive <- intensive
# 
# previous <- Previous
# previous[previous>1] <- 2
# Previous <- previous

## ----eval=FALSE---------------------------------------------------------------
# library(gee)

## ----eval=FALSE---------------------------------------------------------------
# library(VGAM)
# Birth <- as.data.frame(na.omit(cbind(Intensive, Cesarean, Sex, Weight, Previous,
# AgeMother)))
# detach(birth)
# bivarlogit <- vglm(cbind(Intensive , Cesarean) ~ Weight + AgeMother +
# as.factor(Sex) + as.factor(Previous), binom2.or(zero=NULL), data=Birth)
# summary(bivarlogit)

## ----eval=FALSE---------------------------------------------------------------
# n <- dim(Birth)[1]
# ID <- rep(1:n,2)
# 
# InterceptInt <- InterceptCes <- rep(1, 2*n)
# InterceptInt[(n+1):(2*n)] <- InterceptCes[1:n] <- 0
# 
# AgeMotherInt <- AgeMotherCes <- rep(Birth$AgeMother,2)
# AgeMotherInt[(n+1):(2*n)] <- AgeMotherCes[1:n] <- 0
# 
# SexInt <- SexCes <- rep(Birth$Sex,2)
# SexInt[SexInt==1] <- SexCes[SexCes==1] <- 0
# SexInt[SexInt==2] <- SexCes[SexCes==2] <- 1
# SexInt[(n+1):(2*n)] <- SexCes[1:n] <- 0
# 
# PrevBase <- rep(Birth$Previous,2)
# PreviousInt1 <- PreviousCes1 <- PreviousInt2 <- PreviousCes2 <- rep(0, 2*n)
# PreviousInt1[PrevBase==1] <- PreviousCes1[PrevBase==1] <- 1
# PreviousInt2[PrevBase>=2] <- PreviousCes2[PrevBase>=2] <- 1
# PreviousInt1[(n+1):(2*n)] <- PreviousInt2[(n+1):(2*n)] <- PreviousCes1[1:n] <-
#   PreviousCes2[1:n] <- 0
# 
# WeightInt <- WeightCes <- rep(Birth$Weight,2)
# WeightInt[(n+1):(2*n)] <- WeightCes[1:n] <- 0

## ----eval=FALSE---------------------------------------------------------------
# GeeDat <- as.data.frame(cbind(ID, InterceptInt, InterceptCes, SexInt , SexCes ,
# WeightInt , WeightCes , PreviousInt1 , PreviousInt2, PreviousCes1,
# PreviousCes2, AgeMotherInt , AgeMotherCes, Response=
# c(Birth$Intensive, Birth$Cesarean)))

## ----eval=FALSE---------------------------------------------------------------
# gee1 <- gee (Response ~ -1 + InterceptInt + InterceptCes + WeightInt + WeightCes
#              + AgeMotherInt + AgeMotherCes + SexInt + SexCes +
# PreviousInt1 + PreviousCes1 + PreviousInt2 + PreviousCes2,
# family=binomial(link=logit), id=ID, data=GeeDat)
# 
# summary(gee1)

## ----eval=FALSE---------------------------------------------------------------
# coefficients(bivarlogit)[1:2]
# coefficients(gee1)[1:2]
# 
# coefficients(bivarlogit)[4:5]
# coefficients(gee1)[3:4]
# 
# coefficients(bivarlogit)[7:8]
# coefficients(gee1)[5:6]
# 
# coefficients(bivarlogit)[10:11]
# coefficients(gee1)[7:8]
# 
# coefficients(bivarlogit)[13:14]
# coefficients(gee1)[9:10]
# 
# coefficients(bivarlogit)[16:17]
# coefficients(gee1)[11:12]

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# detach(package:VGAM)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=60)

## ----results='hide',eval=FALSE------------------------------------------------
# library(catdata)
# data(unemployment)
# attach(unemployment)

## ----eval=FALSE---------------------------------------------------------------
# durbin <- as.factor(durbin)
# table.durbin <- ftable(subset(unemployment, select=c("age", "durbin")),
# col.vars="durbin")
# rels<-table.durbin[,1]/rowSums(table.durbin)
# age.new <- min(age):max(age)
# 
# model1 <- glm(table.durbin ~ age.new, family=binomial)
# summary(model1)

## ----eval=FALSE---------------------------------------------------------------
# plot(age.new, model1$fitted.values, xlab="Age", ylab="Observed/Fitted values",
# type="l", ylim=c(0,1))
# points(age.new,table.durbin[,1]/rowSums(table.durbin))

## ----eval=FALSE---------------------------------------------------------------
# plot(model1$fitted.values,sqrt(rowSums(table.durbin))*rstandard(model1),
# xlab="Predicted values", ylab="Residuals")

## ----eval=FALSE---------------------------------------------------------------
# qqnorm(sqrt(rowSums(table.durbin))*rstandard(model1), main="",
#        ylab="Standardized deviance residuals")
# qqline(sqrt(rowSums(table.durbin))*rstandard(model1), lwd=2.5,
#        lty="dashed", col="red")

% \VignetteIndexEntry{Arthritis - Cumulative Logit Model}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
    \documentclass[a4paper]{article}

\title{Arthritis - Cumulative Logit Model}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=80)
@


A simple data frame for the arthritis data is created with the numbers given for the individual cells.

<<eval=FALSE>>=
arthritis <- data.frame(drug=c(rep("new agent", 24+37+21+19+6), 
rep("active control", 11+51+22+21+7)), 
assessment=c(rep(1,24), rep(2,37), rep(3,21), rep(4,19), rep(5,6), rep(1,11), 
rep(2,51), rep(3,22), rep(4,21), rep(5,7)))
@

<<eval=FALSE>>=
library(VGAM)
@

Now a cumulative model is fitted.

<<eval=FALSE>>=
cumart <- vglm(assessment ~ drug, family=cumulative(parallel=TRUE, link="logitlink"), 
              data=arthritis)
@

<<eval=FALSE>>=
summary(cumart)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Retinopathy - Testing Proportional Odds Assumption}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
    \documentclass[a4paper]{article}

\title{Retinopathy - Testing Proportional Odds Assumption}

\begin{document}

<<include=FALSE>>=
library(knitr)
opts_chunk$set(
concordance=TRUE
)
@


\maketitle

<<echo=FALSE>>=
options(width=60)
rm(list=ls(all=TRUE))
@

<<results='hide'>>=
library(catdata)
data(retinopathy)
retinopathy$SM <- as.factor(retinopathy$SM)
@

For the fitting of the partial proportional odds models the function "vglm" from the "VGAM"--package is used. First a simple
proportional odds model is fitted with "vglm". 

For the "vglm"--function the response (RET) does not necessarily have to be ordered, SM has to be factorized.

<<>>=
library(VGAM)
# retinopathy$RET <- as.ordered(retinopathy$RET)
# retinopathy$SM <- as.factor(retinopathy$SM)
@


The models differ in the option "parallel" for the used family "cumulative". 

<<results='hide'>>=
pom <- vglm(RET ~ SM + DIAB + GH + BP, 
            family = cumulative(parallel=TRUE), data = retinopathy)
@

<<results='hide'>>=
ppom <- vglm(RET ~ SM + DIAB + GH + BP, 
             family = cumulative(parallel=FALSE), 
             data = retinopathy)
@

First the proportional odds assumption is tested. The deviances of the two models can be received by the following command.

<<>>=
deviance(pom)
@

<<>>=
deviance(ppom)
@

The p--value for the proportional odds assuption is computed:

<<>>=
1 - pchisq(deviance(pom) - deviance(ppom), df=4)
@

Coefficients and standard errors of both models are obtainen in the corresponding summaries. 
\bigskip

Summary proportional odds model:
<<>>=
summary(pom)
@

\bigskip
Summary partial proportional odds model:
<<>>=
summary(ppom)
@

\bigskip

Now the proportional odds assumption for all covariates is taken away step by step. 
Afterwards the corresponding proportional odds assumptions are tested. 

\bigskip
 
Global effect for BP:
<<>>=
ppom2 <- vglm (RET ~ SM + DIAB + GH + BP,
family = cumulative (parallel = FALSE ~ SM + DIAB + GH), data = retinopathy)
deviance(ppom2)
@

<<>>=
1-pchisq(deviance(ppom2)-deviance(ppom), df=1)
@


Global effect for GH:
<<>>=
ppom3 <- vglm (RET ~ SM + DIAB + GH + BP, 
family = cumulative (parallel = FALSE ~ SM + DIAB), data = retinopathy)
deviance(ppom3)
@

<<>>=
1-pchisq(deviance(ppom3)-deviance(ppom2), df=1)
@

Global effect for DIAB:
<<>>=
ppom4 <- vglm (RET ~ SM + DIAB + GH + BP, 
family = cumulative (parallel = FALSE ~ SM), data = retinopathy)
deviance(ppom4)
@

<<>>=
1-pchisq(deviance(ppom4)-deviance(ppom3), df=1)
@

Global effect for SM (equivalent to proportional odds model):
<<>>=
1-pchisq(deviance(pom)-deviance(ppom4), df=1)
@

<<echo=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Knee Injuries - Proportional Odds Models}
% \VignetteDepends{rms, MASS, VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Injuries - Proportional Odds Models}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=80)
@


At the beginning the knee dataset is loaded:

<<results='hide',eval=FALSE>>=
rm(list=ls(all=TRUE))
library(catdata)
data(knee)
attach(knee)
@

First of all a simple $\chi^{2}$ -- test of independence between the therapy (Th) and the pain level (R4) is applied.
<<eval=FALSE>>=
suppressWarnings(chisq.test(knee$Th,knee$R4))
@

In the following the variable Age is centered around $30$ years and the quadratic variable Age2 is created.
<<eval=FALSE>>=
Age <- Age - 30
Age2 <- Age^2
@

The response pain (R4) has to be an ordered factor, the covariates therapy (Th) and sex (Sex) need to be factors.
<<eval=FALSE>>=
R4 <- as.ordered(R4)
Th <- as.factor(Th)
Sex <- as.factor(Sex)
@

A proportional odds model can be fitted by the function "polr" from the "MASS" -- library. Attention has to be paid to the algebraic signs of the coefficients.
These are inverse to the usual interpretation in porportional odds models.
<<eval=FALSE>>=
library(MASS)
@

The first model only uses therapy as covariate, to achieve a proportional odds model the option "method" needs to use the logistic link function.

<<results='hide',eval=FALSE>>=
polr1 <- polr(R4 ~ Th, method="logistic")
@

<<eval=FALSE>>=
summary(polr1)
@

The corresponding odds--ratio can be recieved by the following command (consider the inverse sign!):
<<eval=FALSE>>=
exp(-coef(polr1))
@



Now a model with the covariates therapy, sex and age is fitted.
<<results='hide',eval=FALSE>>=
polr2 <- polr(R4 ~ Th + Sex + Age, method="logistic")
@

<<eval=FALSE>>=
summary(polr2)
@

Odds--ratios for the second model:
<<eval=FALSE>>=
exp(-coef(polr2))
@

To get the Wald--statistic, the standard errors have to be extracted from the summary.
Afterwards the Wald--statistic and the corresponding p--values are easily recieved.

<<eval=FALSE>>=
se <- summary(polr2)[1][[1]][1:3,2]
(wald2 <- -coef(polr2)/se)
@

P--values for the second model:
<<eval=FALSE>>=
1-pchisq(wald2^2, df=1)
@


Finally the quadratic age--effect is added to the previous model.
<<results='hide',eval=FALSE>>=
polr3 <- update(polr2, ~. + Age2)
@

<<eval=FALSE>>=
summary(polr3)
@

Odds--ratios for the final model:
<<eval=FALSE>>=
exp(-coef(polr3))
@

Wald--statistic for the final model:

<<eval=FALSE>>=
se <- summary(polr3)[1][[1]][1:4,2]
(wald3 <- -coef(polr3)/se)
@

P--values for the final model:
<<eval=FALSE>>=
1-pchisq(wald3^2, df=1)
@

As the proportional odds--model is the most popular model for ordinal data, there are several
different ways to fit such models. Now the final model is additionally fitted with function "vglm" 
from the "VGAM"--library and with function "lrm" from the "rms"--library.

\bigskip

Model fitted with "vglm":

<<eval=FALSE>>=
library(VGAM)
@

<<eval=FALSE>>=
m.vglm <- vglm(R4 ~ Th + Sex + Age + Age2, family = cumulative (link="logitlink", 
parallel=TRUE))
summary(m.vglm)
@

The resulting coefficients are very similar to the coefficients in the model above fitted
with function "polr", but they have inverse signs. Therefore they can be interpreted in the usual way.

\bigskip

Model fitted with "lrm":
<<eval=FALSE>>=
library(rms)
@

<<eval=FALSE>>=
m.lrm <- lrm(R4 ~ Th + Sex + Age + Age2)
m.lrm
@

Again no big differences are found concerning the coefficients. Here the signs are the same as with the function "polr".

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Knee Injuries - Comparison of Link Functions}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Injuries - Comparison of Link Functions}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=80)
rm(list=ls(all=TRUE))
@

At the beginning the knee dataset is loaded:
<<results='hide',eval=FALSE>>=
library(catdata)
data(knee)
attach(knee)
@


In the following the variable Age is centered around $30$ years and the quadratic variable Age2 is created. 

<<eval=FALSE>>=
Age <- Age - 30
Age2 <- Age^2
@

For the cumulative maximum extreme value (Gumbel) model that will be fitted later, the response has to be transformed so that afterwards the
ordering of the response categories is reversed. 

<<eval=FALSE>>=
k <- length(unique(R4))
R4rev <- k + 1 - R4
@ 

The response pain (R4 or R4rev) is an ordered factor, the covariates therapy (Th) and sex (Sex) need to be factors.

<<eval=FALSE>>=
R4 <- as.ordered(R4)
R4rev <- as.ordered(R4rev)
Th <- as.factor(Th)
Sex <- as.factor(Sex)
@
 
With the "vglm"--function from the "VGAM"--library both cumulative and sequential models can be fitted.
<<eval=FALSE>>=
library(VGAM)
@

To compare the performance of cumulative models with different link functions one can use the deviances of the respective models. At first four models with 
four different link functions (Logit, Probit, Gumbel, Gompertz) are fitted.

\bigskip

Cumulative Logit model:
<<eval=FALSE>>=
clogit <- vglm(R4 ~ Th + Sex + Age +Age2, family = cumulative (link="logitlink", 
parallel=TRUE))
@

Cumulative Probit model:
<<eval=FALSE>>=
cprobit <- vglm(R4 ~ Th + Sex + Age +Age2, family = cumulative (link="probitlink",
parallel=TRUE))
@

Cumulative Gumbel model:
<<eval=FALSE>>=
cgumbel <- vglm(R4rev ~ Th + Sex + Age +Age2, family = cumulative(link="clogloglink", 
parallel=TRUE))
@

Cumulative Gompertz model:
<<eval=FALSE>>=
cgompertz <- vglm(R4 ~ Th + Sex + Age +Age2, family = cumulative(link="clogloglink", 
parallel=TRUE))
@

\bigskip

Now the four deviances can be recalled by the following command:
<<eval=FALSE>>=
deviance(clogit)
deviance(cprobit)
deviance(cgumbel)
deviance(cgompertz)
@

For comparison the four corresponding sequential models are fitted.

\bigskip

Sequential Logit model:
<<eval=FALSE>>=
slogit <- vglm(R4 ~ Th + Sex + Age +Age2, family = sratio (link="logitlink", 
parallel=TRUE))
@

Sequential Probit model:
<<eval=FALSE>>=
sprobit <- vglm(R4 ~ Th + Sex + Age +Age2, family = sratio (link="probitlink", 
parallel=TRUE))
@

Sequential Gumbel model:
<<eval=FALSE>>=
sgumbel <- vglm(R4rev ~ Th + Sex + Age +Age2, family = sratio (link="clogloglink", 
parallel=TRUE))
@

Sequential Gompertz model:
<<eval=FALSE>>=
sgompertz <- vglm(R4 ~ Th + Sex + Age +Age2, family = sratio (link="clogloglink",
parallel=TRUE))
@

Now the deviances of the sequential models are recalled:
<<eval=FALSE>>=
deviance(slogit)
deviance(sprobit)
deviance(sgumbel)
deviance(sgompertz)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Retinopathy - Sequential Logit Models}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Retinopathy - Sequential Logit Models}

\begin{document}

<<include=FALSE>>=
library(knitr)
opts_chunk$set(
concordance=TRUE
)
@


\maketitle

<<echo=FALSE>>=
rm(list=ls(all=TRUE))
options(width=80)
@

<<results='hide'>>=
library(catdata)
data(retinopathy)
@

For sequential models again the "vglm"--function from the "VGAM"--library is needed, but now family option "sratio" is required.
<<>>=
library(VGAM)
@

Now several sequential logit models are fitted and compared by their corresponding deviances. The first model
is the sequential logit model with all category--specific effects, so the option "parallel=FALSE" is used.

<<>>=
seqm1 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logitlink", 
parallel=FALSE), data = retinopathy)
deviance(seqm1)
@

No category--specific effect for DIAB:

<<>>=
seqm2 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logitlink", 
parallel=FALSE ~ SM + GH + BP), data = retinopathy)
deviance(seqm2)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm2)-deviance(seqm1), df=1)
@

No category--specific effect for GH:

<<>>=
seqm3 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logitlink", 
parallel=FALSE ~ SM + BP), data = retinopathy)
deviance(seqm3)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm3)-deviance(seqm2), df=1)
@

No category--specific effect for BP:

<<>>=
seqm4 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logitlink", 
parallel=FALSE ~ SM), data = retinopathy)
deviance(seqm4)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm4)-deviance(seqm3), df=1)
@

No category--specific effect for GH (only global effects):

<<>>=
seqm5 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logitlink", 
parallel=TRUE), data = retinopathy)
deviance(seqm5)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm5)-deviance(seqm4), df=1)
@

As the last test is significant, model "seqm4" is analyzed in detail.

<<>>=
summary(seqm4)
@

The summary gives no p--values for the individual covariates, they have to be computed separately. 
For this purpose the t--values are copied from the summary. The quadratic t--values are the wald--statistics which can be used to produce the individual 
p--values.

\bigskip

p--value intercept1:
<<>>=
1 - pchisq(9.5223^2, df=1)
@

p--value intercept2:
<<>>=
1 - pchisq(8.9957^2, df=1)
@

p--value SM1:
<<>>=
1 - pchisq((-1.8646)^2, df=1)
@

p--value SM2:
<<>>=
1 - pchisq(1.5687^2, df=1)
@

p--value DIAB:
<<>>=
1 - pchisq((-10.4303)^2, df=1)
@

p-value GH:
<<>>=
1 - pchisq((-6.3116)^2, df=1)
@

p--value BP:
<<>>=
1 - pchisq((-5.1037)^2, df=1)
@

To receive the corresponding odds--ratios, the following command can be used.

<<>>=
exp(coefficients(seqm4)[3:7])
@


<<echo=FALSE>>=
detach(package:VGAM)
@
\end{document}
